<script lang="ts">
    import { onDestroy } from 'svelte';
    import { metatags, goto } from '@roxi/routify';
    import axios from 'axios';
    import { IWalletRequestElements, Utils } from '../../classes/utils';
    import { Toast } from '../../classes/toast';

    metatags.title = 'Around me';
    metatags.description = 'Description coming soon...';

    let userIdList: string[] = [];

    let loading: boolean = false;
    const refreshSeconds: number = 10;
    let refreshValue: number = 0;
    const interval: number = 100;

    const intervalId: NodeJS.Timeout = setInterval(() => {
        refreshValue -= interval/1000;
        if (refreshValue <= 0 && !loading) {
            loading = true;
            navigator.geolocation.getCurrentPosition((position: Position) => {
                let lat: number = position.coords.latitude;
                let lon: number = position.coords.longitude;

                Utils.getWalletRequestElements()
                    .then((elements: IWalletRequestElements) => {
                        axios.post('/api/around-me', {lat, lon, pk: elements.pk, qs: elements.qs, signature: elements.signature})
                            .then(xhr => {
                                userIdList = xhr.data;
                            })
                            .catch(err => {
                                Toast.failure('Could not retrieve users around you: ' + err.message);
                            })
                            .finally(() => {
                                refreshValue = refreshSeconds;
                                loading = false;
                            });
                    });

            }, (error: PositionError) => {
                Toast.failure('Could not retrieve your GPS coordinates: ' + error.message);
                refreshValue = refreshSeconds;
                loading = false;
            }, {timeout: 8000});

        }
    }, interval);

    onDestroy(() => {
        clearInterval(intervalId);
    });

</script>

<style lang="scss">
    .refresh-progress {
        width: 20%;
    }
</style>

<div class="has-text-centered">
    <div class="is-flex is-align-items-center is-flex-direction-column">
        <small>The user list will soon be refreshed</small>
        <div class="refresh-progress">
            <progress class="progress" value="{refreshValue}" max="10">15%</progress>
        </div>
        <br>
        {#if userIdList.length > 0}
            {#each userIdList as userId}
                <button class="button" on:click={() => $goto('./user/'+userId)}>{userId}</button>
            {/each}
        {:else}
            <p>No user found around you for instance.</p>
        {/if}
    </div>
</div>
